package com.virtual.plat.server.rs.warnmanage.func;

import com.virtual.common.AppException;
import com.virtual.common.StringManager;
import com.virtual.plat.server.entity.Domain;
import com.virtual.plat.server.entity.EventStrategy;
import com.virtual.plat.server.entity.EventStrategyDomain;
import com.virtual.plat.server.entity.OrgUser;
import com.virtual.plat.server.entity.QueryConfig;
import com.virtual.plat.server.entity.QueryResult;
import com.virtual.plat.server.entity.UserVm;
import com.virtual.plat.server.organize.OrganizationMgr;
import com.virtual.plat.server.rs.entity.ListResult;
import com.virtual.plat.server.rs.vm.entity.RsDomain;
import com.virtual.plat.server.rs.warnmanage.entity.RsDomainEvent;
import com.virtual.plat.server.rs.warnmanage.entity.RsEventDetail;
import com.virtual.plat.server.rs.warnmanage.entity.RsEventParams;
import com.virtual.plat.server.rs.warnmanage.entity.RsEventStrategy;
import com.virtual.plat.server.rs.warnmanage.entity.RsEventStrategyDomain;
import com.virtual.plat.server.rs.warnmanage.func.RsEventMgr;
import com.virtual.plat.server.user.UserMgr;
import com.virtual.plat.server.virtualhost.DomainMgr;
import com.virtual.plat.server.virtualhost.DomainUtils;
import com.virtual.plat.server.warnmanage.WarnManageHandler;
import com.virtual.plat.server.warnmanage.WarnManageMgr;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import javax.annotation.Resource;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Service;

@Service("rsEventMgr")
public class RsEventMgrImpl implements RsEventMgr {

   @Resource
   private WarnManageMgr warnManageMgr = null;
   @Resource
   private WarnManageHandler warnManageHandler = null;
   @Resource
   private DomainMgr domainMgr = null;
   @Resource
   private UserMgr userMgr = null;
   protected Log log = LogFactory.getLog(this.getClass());
   private static StringManager sm = StringManager.getManager("com.virtual.plat.server.rs.common");
   @Resource
   private OrganizationMgr organizationMgr = null;


   public Long addEventStrategy(RsEventStrategy var1) {
      EventStrategy var2;
      (var2 = new EventStrategy()).setName(var1.getName());
      var2.setUserId(var1.getUserId());
      var2.setDescription(var1.getDescription());
      var2.setState(var1.getState());
      var2.setId(var1.getId());
      return this.warnManageMgr.addEventStrategy(var2);
   }

   public Long modifyUserWarnStrategy(RsEventStrategy var1) {
      return var1.getId();
   }

   public void startUserWarnStrategy(Long var1) {
      if(this.warnManageMgr.modifyUserWarnStrategy(var1, EventStrategy.EVENT_STRATEGY_STATE_OPEN)) {
         this.updateWarnDomainBaseTime(var1);
      }

   }

   public void stopUserWarnStrategy(Long var1) {
      this.warnManageMgr.modifyUserWarnStrategy(var1, EventStrategy.EVENT_STRATEGY_STATE_CLOSE);
   }

   public void addUserWarnDomain(RsEventStrategyDomain var1) {
      Long var2 = var1.getEventStrategyId();
      List var7 = var1.getVmIds();
      EventStrategy var3 = this.warnManageMgr.readEventStrategyById(var2);
      UserVm var4 = new UserVm();
      Long var9 = var3.getUserId();
      var4.setUserId(var9);
      QueryConfig var5;
      (var5 = new QueryConfig()).addRestriction("userId", var9);
      Long var6 = ((OrgUser)this.organizationMgr.queryOrgUserByCondition(var5).getData().get(0)).getOrgId();
      var4.setOrgId(var6);
      Map var8 = this.warnManageHandler.queryVMWarningBaseInfo(var7);
      this.warnManageMgr.addEventStrategyDomain(var9, var2, var8);
   }

   public void updateWarnDomainBaseTime(Long var1) {
      QueryConfig var2;
      (var2 = new QueryConfig()).addRestriction("eventStrategyId", var1);
      QueryResult var5;
      if((var5 = this.warnManageMgr.readEventStrategyDomainList(var2)) != null && var5.getData() != null && var5.getData().size() > 0) {
         List var6 = var5.getData();
         ArrayList var3 = new ArrayList();
         Iterator var7 = var6.iterator();

         while(var7.hasNext()) {
            EventStrategyDomain var4 = (EventStrategyDomain)var7.next();
            var3.add(var4.getDomainId());
         }

         Map var8 = this.warnManageHandler.queryVMWarningBaseInfo(var3);
         this.warnManageMgr.updateStrategyDomain(var1, var8);
      }
   }

   public void deleteUserWarnDomain(RsEventStrategyDomain var1) {
      List var2;
      if((var2 = var1.getVmIds()) != null) {
         this.warnManageMgr.batchDelEventStrategyDomainByDomainIds(var2);
      }
   }

   public RsEventStrategy userEventStrategy(Long var1) {
      QueryConfig var2;
      (var2 = new QueryConfig()).addRestriction("userId", var1);
      QueryResult var4;
      RsEventStrategy var5;
      if((var4 = this.warnManageMgr.queryEventIdListByCondition(var2)).getData() != null && var4.getData().size() > 0) {
         EventStrategy var3 = (EventStrategy)var4.getData().get(0);
         (var5 = new RsEventStrategy()).setId(var3.getId());
         var5.setUserId(var3.getUserId());
         var5.setState(var3.getState());
         return var5;
      } else {
         (var5 = new RsEventStrategy()).setUserId(var1);
         var5.setState(EventStrategy.EVENT_STRATEGY_STATE_CLOSE);
         var1 = this.addEventStrategy(var5);
         var5.setId(var1);
         return var5;
      }
   }

   public ListResult queryUserWarnInfos(Long var1, Long var2, Integer var3, Long var4, Integer var5, Integer var6, String var7) {
      QueryConfig var8;
      (var8 = new QueryConfig()).addRestriction("userId", var1);
      QueryResult var12;
      if((var12 = this.warnManageMgr.queryEventIdListByCondition(var8)).getLength() == 0) {
         return new ListResult();
      } else {
         EventStrategy var13;
         if((var13 = (EventStrategy)var12.getData().get(0)).getState() == EventStrategy.EVENT_STRATEGY_STATE_CLOSE) {
            Object[] var16 = new Object[]{sm.getString("user.warn.close")};
            throw new AppException(16, var16);
         } else {
            QueryConfig var9;
            (var9 = new QueryConfig()).addRestriction("eventStrategyId", var13.getId());
            if((var12 = this.warnManageMgr.readEventStrategyDomainList(var9)) == null) {
               return new ListResult();
            } else {
               List var14 = var12.getData();
               HashMap var15 = new HashMap();
               Iterator var17 = var14.iterator();

               while(var17.hasNext()) {
                  EventStrategyDomain var10 = (EventStrategyDomain)var17.next();
                  if(var15.keySet().contains(var10.getPublicCloudId())) {
                     ((List)var15.get(var10.getPublicCloudId())).add(var10);
                  } else {
                     ArrayList var11;
                     (var11 = new ArrayList()).add(var10);
                     var15.put(var10.getPublicCloudId(), var11);
                  }
               }

               return this.a(var15, var1, var2, var3, var4, var5, var6, var7);
            }
         }
      }
   }

   private ListResult a(Map var1, Long var2, Long var3, Integer var4, Long var5, Integer var6, Integer var7, String var8) {
      ArrayList var9 = new ArrayList();
      int var10 = 0;
      Iterator var17 = var1.entrySet().iterator();

      while(var17.hasNext()) {
         Entry var11 = (Entry)var17.next();
         ArrayList var12 = new ArrayList();
         if(var3 == null && var8 == null) {
            Iterator var22 = ((List)var11.getValue()).iterator();

            while(var22.hasNext()) {
               EventStrategyDomain var24 = (EventStrategyDomain)var22.next();
               RsDomainEvent var15 = new RsDomainEvent();
               String var16 = DomainUtils.getUniqueKeyByDomainId(var24.getDomainId(), this.domainMgr);
               var15.setDomainId(Long.valueOf(var16));
               Date var26 = var24.getBaseEventTime();
               var15.setLastEventTime(var26);
               var15.setLastEventId(var24.getBaseEventId());
               var12.add(var15);
            }
         } else {
            QueryResult var13;
            if((var13 = this.userMgr.queryUserEventStrategyDomainIdList(var2, var8)).getLength() > 0) {
               if(var3 == null && var8 != null) {
                  this.a((List)var11.getValue(), var12, var13.getData());
               } else {
                  List var14;
                  if(!(var14 = var13.getData()).contains(var3)) {
                     var14.add(var3);
                  }

                  this.a((List)var11.getValue(), var12, var14);
               }
            }
         }

         RsEventParams var23;
         (var23 = new RsEventParams()).setCatalogId(var5);
         var23.setEventLevel(var4);
         var23.setList(var12);
         ListResult var25;
         if((var25 = this.warnManageHandler.queryVMWarnInfos(var23, (Long)var11.getKey())).getData() != null) {
            var10 = (int)((long)var10 + var25.getSize());
            var9.addAll(var25.getData());
         }
      }

      ListResult var18;
      (var18 = new ListResult()).setSize((long)var10);
      List var19;
      Iterator var20 = (var19 = var9.subList(var6.intValue(), var7.intValue() + var6.intValue() > var9.size()?var9.size():var7.intValue() + var6.intValue())).iterator();

      while(var20.hasNext()) {
         RsEventDetail var21;
         if((var21 = (RsEventDetail)var20.next()).getFirstEventTime() == null) {
            var21.setFirstEventTime(var21.getEventTime());
            var21.setEventCount(Long.valueOf(1L));
         }
      }

      var18.setData(var19);
      return var18;
   }

   private void a(List var1, List var2, List var3) {
      Iterator var8 = var1.iterator();

      while(var8.hasNext()) {
         EventStrategyDomain var4 = (EventStrategyDomain)var8.next();
         if(var3.contains(var4.getDomainId())) {
            RsDomainEvent var5 = new RsDomainEvent();
            String var6 = DomainUtils.getUniqueKeyByDomainId(var4.getDomainId(), this.domainMgr);
            var5.setDomainId(Long.valueOf(var6));
            Date var7 = var4.getBaseEventTime();
            var5.setLastEventTime(var7);
            var5.setLastEventId(var4.getBaseEventId());
            var2.add(var5);
         }
      }

   }

   public QueryResult eventStrategyDomainList(QueryConfig var1) {
      ArrayList var2 = new ArrayList();
      Integer var3 = Integer.valueOf(var1.getOffset());
      Integer var4 = Integer.valueOf(var1.getLimit());
      if(var1.getRestriction("eventStrategyId") == null) {
         QueryConfig var5;
         (var5 = new QueryConfig()).addRestriction("userId", (Long)var1.getRestriction("userId"));
         QueryResult var6;
         if((var6 = this.warnManageMgr.queryEventIdListByCondition(var5)) == null || var6.getData() == null || var6.getData().size() <= 0) {
            return null;
         }

         Long var7 = ((EventStrategy)var6.getData().get(0)).getId();
         var1.addRestriction("eventStrategyId", var7);
      }

      var1.setPagingInfo(0, 0);
      QueryResult var17;
      if((var17 = this.warnManageMgr.readEventStrategyDomainList(var1)) != null && var17.getData() != null && var17.getData().size() > 0) {
         HashMap var20 = new HashMap();
         QueryConfig var21;
         (var21 = new QueryConfig()).addRestriction("userId", (Long)var1.getRestriction("userId"));
         QueryResult var11;
         Iterator var12;
         if((var11 = this.organizationMgr.querySsvVmByCondition(var21)) != null && var11.getData() != null && var11.getData().size() > 0) {
            var12 = var11.getData().iterator();

            while(var12.hasNext()) {
               UserVm var22 = (UserVm)var12.next();
               if(!var20.containsKey(var22.getDomainId())) {
                  var20.put(var22.getDomainId(), var22);
               } else {
                  ((UserVm)var20.get(var22.getDomainId())).setFlag(Integer.valueOf(3));
               }
            }
         }

         List var13 = var17.getData();
         var21 = new QueryConfig();
         ArrayList var8 = new ArrayList();
         var12 = var13.iterator();

         while(var12.hasNext()) {
            EventStrategyDomain var18 = (EventStrategyDomain)var12.next();
            var8.add(var18.getDomainId());
         }

         var21.addRestriction("idList", var8);
         var21.setPagingInfo(var3.intValue(), var4.intValue());
         var11 = this.domainMgr.queryDomainsByCondition(var21);
         SimpleDateFormat var19 = new SimpleDateFormat("yyyy-MM-dd");
         Long var15 = null;
         Long var16 = null;
         if(var11 != null && var11.getData() != null && var11.getData().size() > 0) {
            var15 = Long.valueOf(var11.getTotalLength());
            var16 = Long.valueOf(var11.getOffset());

            RsDomain var14;
            for(Iterator var23 = var11.getData().iterator(); var23.hasNext(); var2.add(var14)) {
               Domain var24 = (Domain)var23.next();
               (var14 = new RsDomain()).setTitle(var24.getTitle());
               var14.setName(var24.getDomainName());
               var14.setId(var24.getId());
               String var9 = var24.getStatus();
               Integer var10 = Integer.valueOf(1);
               if(var9 != null) {
                  if(var9.equals("running")) {
                     var10 = Integer.valueOf(2);
                  } else if(var9.equals("paused")) {
                     var10 = Integer.valueOf(4);
                  } else if(var9.equals("shutOff")) {
                     var10 = Integer.valueOf(3);
                  }
               }

               var14.setStatus(var10);
               var14.setOsVersion(var24.getOsVersion());
               var14.setCpu(var24.getCpu());
               var14.setMemory(var24.getMemory());
               UserVm var26;
               Date var27;
               if((var26 = (UserVm)var20.get(var24.getId())) != null && (var27 = var26.getExpireDate()) != null) {
                  var14.setExpireDate(var27);
                  var14.setExpireDateStr(var19.format(var27));
               }
            }
         }

         QueryResult var25;
         (var25 = new QueryResult()).setData(var2);
         var25.setTotalLength(var15.longValue());
         var25.setOffset(var16.longValue());
         return var25;
      } else {
         return null;
      }
   }

   public void filterDomainWarning(List var1, Long var2) {
      Iterator var3 = var1.iterator();

      while(var3.hasNext()) {
         RsDomain var4;
         if((var4 = (RsDomain)var3.next()).getAssignMode() != null && var4.getAssignMode().intValue() == 2) {
            var3.remove();
         }
      }

      QueryConfig var9;
      (var9 = new QueryConfig()).addRestriction("userId", var2);
      QueryResult var7;
      if((var7 = this.warnManageMgr.queryEventIdListByCondition(var9)) != null && var7.getData() != null && var7.getData().size() > 0) {
         var2 = ((EventStrategy)var7.getData().get(0)).getId();
         (var9 = new QueryConfig()).addRestriction("eventStrategyId", var2);
         Object var8;
         if((var7 = this.warnManageMgr.readEventStrategyDomainList(var9)) != null && var7.getData() != null && var7.getData().size() > 0) {
            var8 = var7.getData();
         } else {
            var8 = new ArrayList();
         }

         var3 = var1.iterator();

         while(var3.hasNext()) {
            RsDomain var6;
            if((var6 = (RsDomain)var3.next()).getPublicCloudType().intValue() == 3) {
               var3.remove();
            } else {
               Iterator var10 = ((List)var8).iterator();

               while(var10.hasNext()) {
                  EventStrategyDomain var5 = (EventStrategyDomain)var10.next();
                  if(var6.getId().equals(var5.getDomainId())) {
                     var3.remove();
                  }
               }

               if(var6.getStatus().intValue() == 1) {
                  var3.remove();
               }
            }
         }

      }
   }

   private static Integer a(String var0) {
      Integer var1 = Integer.valueOf(1);
      if(var0 != null) {
         if(var0.equals("running")) {
            var1 = Integer.valueOf(2);
         } else if(var0.equals("paused")) {
            var1 = Integer.valueOf(4);
         } else if(var0.equals("shutOff")) {
            var1 = Integer.valueOf(3);
         }
      }

      return var1;
   }

}
